
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>iOS开发笔记17：自定义相机拍照 / 憋错料</title>

    <meta name="description" content="iOS开发笔记17：自定义相机拍照 之前用AVFoundation自定义相机做了拍照与视频相关的东西,为什么要自定义呢?主要是提供更个性化的交互设计,符合app主题,对于视频来说,也便于提供更多丰富有趣的功能.前段时间整理了下拍照部分的功能,主要分为以下五个部分 1.初始化,建立会话,获取摄像头 使用AVCaptureSessionPresetPhoto模式,输出的图片分辨率与系统相机输出的分辨率保持一致 添加后置摄像头与图片输出(默认采用后置摄像头拍摄) 2.嵌入实时预览层 获取实时预览画面,添加手势,初始化时默认在画面中心点对">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">iOS开发笔记17：自定义相机拍照</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>之前用AVFoundation自定义相机做了拍照与视频相关的东西，为什么要自定义呢？主要是提供更个性化的交互设计，符合app主题，对于视频来说，也便于提供更多丰富有趣的功能。前段时间整理了下拍照部分的功能，主要分为以下五个部分</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29uZmx1ZW5jZS5zb2h1bm8uY29tL2Rvd25sb2FkL2F0dGFjaG1lbnRzLzI1MTU3MjcwL2ltYWdlMjAxNy02LTMwJTIwMTklM0EyNyUzQTQzLnBuZz92ZXJzaW9uPTEmYW1wO21vZGlmaWNhdGlvbkRhdGU9MTQ5ODgyMjA2MzAwMCZhbXA7YXBpPXYy.jpg" /></p>
<h3><strong>1.初始化，建立会话，获取摄像头</strong></h3>
<p>使用AVCaptureSessionPresetPhoto模式,输出的图片分辨率与系统相机输出的分辨率保持一致</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29uZmx1ZW5jZS5zb2h1bm8uY29tL2Rvd25sb2FkL2F0dGFjaG1lbnRzLzI1MTU3MjcwL2ltYWdlMjAxNy02LTMwJTIwMTYlM0ExNCUzQTM4LnBuZz92ZXJzaW9uPTEmYW1wO21vZGlmaWNhdGlvbkRhdGU9MTQ5ODgxMDQ3OTAwMCZhbXA7YXBpPXYy.jpg" /></p>
<p>添加后置摄像头与图片输出（默认采用后置摄像头拍摄）</p>
<h3><strong>2.嵌入实时预览层</strong></h3>
<p>获取实时预览画面，添加手势，初始化时默认在画面中心点对焦一次并显示对焦框，提示用户可点击画面进行对焦及自动曝光调节。<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29uZmx1ZW5jZS5zb2h1bm8uY29tL2Rvd25sb2FkL2F0dGFjaG1lbnRzLzI1MTU3MjcwL2ltYWdlMjAxNy02LTMwJTIwMTYlM0E1MyUzQTQ0LnBuZz92ZXJzaW9uPTEmYW1wO21vZGlmaWNhdGlvbkRhdGU9MTQ5ODgxMjgyNTAwMCZhbXA7YXBpPXYy.jpg" /></p>
<h3><strong>3.相关设置</strong></h3>
<p>对焦与自动曝光调节</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNy5jbmJsb2dzLmNvbS9ibG9nLzQ2ODIyMS8yMDE3MDkvNDY4MjIxLTIwMTcwOTAxMDAzNTQyNDM3LTkzMjEyNTQ1MC5wbmc=.jpg" /></p>
<p>闪光灯设置</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNy5jbmJsb2dzLmNvbS9ibG9nLzQ2ODIyMS8yMDE3MDkvNDY4MjIxLTIwMTcwOTAxMDAyNTIwNjcxLTEwNzg1MTc2NDYucG5n.jpg" /></p>
<p>切换前后摄像头，_isFrontCameraInput这个标识在最后输出处理拍摄得到的照片时会用到，前置摄像头拍摄的照片需要旋转180度<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNy5jbmJsb2dzLmNvbS9ibG9nLzQ2ODIyMS8yMDE3MDkvNDY4MjIxLTIwMTcwOTAxMDAzODAzNTQ2LTc1MzMzMjk3NS5wbmc=.jpg" /></p>
<h3><strong>4.拍摄获取照片</strong></h3>
<p>有以下几点需要注意下：</p>
<p>（1）view层点击拍照按钮时需要把拍摄时设备的方向信息传过来，最后输出照片时，会根据设备方向对图片进行旋转处理，使得最后输出的结果与系统相机拍摄结果一致。</p>
<p>（注：目前是通过系统自带传感器CMMotionManager获取到设备方向，其实也可以通过照片元数据获取到方向信息，进而做旋转处理）</p>
<p>（2）加入防抖模式，iOS8及以上系统支持。</p>
<p>（3）获取拍摄照片的元数据信息</p>
<p>（4）确定照片裁剪范围，裁剪范围即拍摄预览区域。系统拍摄获取到照片默认是一张全屏照片，但是UI设计上拍摄预览区域非全屏，为了保证所见即所得，需要对拍摄得到的照片进行裁剪，</p>
<p>在iPhone4上拍摄预览区域是一个屏幕等宽区域（考虑到设备尺寸，iPhone4单独设计的尺寸），其他机型上，预览区域是一个宽高比3:4(宽度为屏幕等宽)的区域。</p>
<p>（5）对图片进行裁剪及旋转处理，裁剪方法参考：<a href="https://github.com/mbcharbonneau/UIImage-Categories" rel="external nofollow noreferrer">https://github.com/mbcharbonneau/UIImage-Categories</a></p>
<p>根据拍摄时设备方向信息对照片进行旋转，前置摄像头拍摄照片再单独旋转180度</p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29uZmx1ZW5jZS5zb2h1bm8uY29tL2Rvd25sb2FkL2F0dGFjaG1lbnRzLzI1MTU3MjcwL2ltYWdlMjAxNy02LTMwJTIwMTclM0EyNyUzQTIxLnBuZz92ZXJzaW9uPTEmYW1wO21vZGlmaWNhdGlvbkRhdGU9MTQ5ODgxNDg0MTAwMCZhbXA7YXBpPXYy.jpg" /></strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29uZmx1ZW5jZS5zb2h1bm8uY29tL2Rvd25sb2FkL2F0dGFjaG1lbnRzLzI1MTU3MjcwL2ltYWdlMjAxNy02LTMwJTIwMTclM0EyOCUzQTIyLnBuZz92ZXJzaW9uPTEmYW1wO21vZGlmaWNhdGlvbkRhdGU9MTQ5ODgxNDkwMzAwMCZhbXA7YXBpPXYy.jpg" /></p>
<h3><strong>5.View层UI及交互</strong></h3>
<p>具体的交互设计随实际情况而定。</p>
<p>有以下几点需要注意下：</p>
<p>（1）进入拍照页面即启动传感器监听，方便获取拍摄时设备方向信息，销毁需要关闭。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29uZmx1ZW5jZS5zb2h1bm8uY29tL2Rvd25sb2FkL2F0dGFjaG1lbnRzLzI1MTU3MjcwL2ltYWdlMjAxNy02LTMwJTIwMTklM0EyMSUzQTQ4LnBuZz92ZXJzaW9uPTEmYW1wO21vZGlmaWNhdGlvbkRhdGU9MTQ5ODgyMTcwODAwMCZhbXA7YXBpPXYy.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29uZmx1ZW5jZS5zb2h1bm8uY29tL2Rvd25sb2FkL2F0dGFjaG1lbnRzLzI1MTU3MjcwL2ltYWdlMjAxNy02LTMwJTIwMTklM0EyMyUzQTQ1LnBuZz92ZXJzaW9uPTEmYW1wO21vZGlmaWNhdGlvbkRhdGU9MTQ5ODgyMTgyNTAwMCZhbXA7YXBpPXYy.jpg" /></p>
<p>（2）切换闪光灯效果（打开/关闭/自动）时，记得保存用户选择，下一次拍照时恢复该设置（与系统相机行为一致）</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-15 06:15:54 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/logs/" title="logs">logs</a>, <a href="https://www.biecuoliao.com/tag/cat/" title="cat">cat</a>, <a href="https://www.biecuoliao.com/tag/%e6%8a%80%e6%9c%af/" title="技术">技术</a>, <a href="https://www.biecuoliao.com/tag/%e5%8a%9f%e8%83%bd/" title="功能">功能</a>, <a href="https://www.biecuoliao.com/tag/amp/" title="amp">amp</a>, <a href="https://www.biecuoliao.com/tag/%e8%87%aa%e5%b8%a6/" title="自带">自带</a>, <a href="https://www.biecuoliao.com/tag/%e5%b1%8f%e5%b9%95/" title="屏幕">屏幕</a>, <a href="https://www.biecuoliao.com/tag/%e5%b0%ba%e5%af%b8/" title="尺寸">尺寸</a>, <a href="https://www.biecuoliao.com/tag/attach/" title="attach">attach</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>iOS开发笔记17：自定义相机拍照的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgLl1N0.html" rel="bookmark">iOS开发多线程之自定义NSOperation</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS开发多线程篇—自定义NSOperation 一.实现一个简单的tableView显示效果 实现效果展示: 代码示例(使用以前在主控制器中进行业务处理的方式) 1.新建一个项目,让控制器继承自UITableViewController. 1 // 2 // YYViewController.h 3 // 01-自定义Operation 4 // 5 // Created by apple on 14-6-26. 6 // Copyright (c) 2014年 itcase. All rig			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NJgoy4.html" rel="bookmark">iOS开发多线程篇&mdash;自定义NSOperation</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS开发多线程篇—自定义NSOperation 一.实现一个简单的tableView显示效果 实现效果展示: 代码示例(使用以前在主控制器中进行业务处理的方式) 1.新建一个项目,让控制器继承自UITableViewController. 1 // 2 // YYViewController.h 3 // 01-自定义Operation 4 // 5 // Created by apple on 14-6-26. 6 // Copyright (c) 2014年 itcase. All rig			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rE8vq0.html" rel="bookmark">iOS开发UI篇&mdash;自定义瀑布流控件（蘑菇街数据刷新操作）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS开发UI篇—自定义瀑布流控件(蘑菇街数据刷新操作) 一.简单说明 使用数据刷新框架: 该框架提供了两种刷新的方法,一个是使用block回调(存在循环引用问题,_ _weak),一个是使用调用. 问题:在进行下拉刷新之前,应该要清空之前的所有数据(在刷新数据这个方法中). 移除正在显示的cell: (1)把字典中的所有的值,都从屏幕上移除 (2)清除字典中的所有元素 (3)清除cell的frame,每个位置的cell的frame都要重新计算 (4)清除可复用的缓存池. 该部分的代码如下: 1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35AGYo3.html" rel="bookmark">iOS开发UI篇&mdash;自定义瀑布流控件（基本实现）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS开发UI篇—自定义瀑布流控件(基本实现) 一.基本实现 说明:在View加载的时候,刷新数据. 1.实现代码 YYViewController.m文件 1 // 2 // YYViewController.m 3 // 06-瀑布流 4 // 5 // Created by apple on 14-7-28. 6 // Copyright (c) 2014年 wendingding. All rights reserved. 7 // 8 9 #import &quot;YYViewControll			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dEnKn3.html" rel="bookmark">iOS开发UI篇&mdash;自定义瀑布流控件（蘑菇街实现）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS开发UI篇—自定义瀑布流控件(蘑菇街瀑布流) 一.简单说明 关于瀑布流 1.是使用UIScrollView实现的 2.刷新数据(reloadData)方法里面做哪些事情 3.layoutSubviews方法里面做哪些事情 4.模仿UItableView进行设计 完善: 瀑布流控件第一次显示到屏幕上的时候自动的向数据源索要数据,而不需要手动调用.这需要监听View的显示,View的显示有一个方法,叫做willMoveToSuperview:在该方法中直接刷新一次数据即可. 二.把自定义的瀑布			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MW2AmG4.html" rel="bookmark">iOS开发UI篇&mdash;自定义瀑布流控件（接口设计）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS开发UI篇—自定义瀑布流控件(接口设计) 一.简单说明 1.关于瀑布流 电商应用要展示商品信息通常是通过瀑布流的方式,因为每个商品的展示图片,长度和商都都不太一样. 如果不用瀑布流的话,展示这样的格子数据,还有一种办法是使用九宫格. 但利用九宫格有一个缺点,那就是每个格子的宽高是一样的,如果一定要使用九宫格来展示,那么展示的商品图片可能会变形. 为了保证商品图片能够按照原来的宽高比进行展示,一般采用的是瀑布流的方式. 2.瀑布流的特点: 由很多的格子组成,但是每个格子的宽度和高速都是不确定			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MV2PVyM.html" rel="bookmark">iOS开发UI篇&mdash;自定义瀑布流控件（cell的循环利用）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS开发UI篇—自定义瀑布流控件(cell的循环利用) 一.简单说明 当滚动的时候,向数据源要cell. 当UIScrollView滚动的时候会调用layoutSubviews在tableView中也是一样的,因此,可以用这个方法来监听scrollView的滚动,可以在在这个地方向数据源索要对应位置的cell(frame在屏幕上的cell). 示例: 当scrollView在屏幕上滚动的时候,离开屏幕的cell应该放到缓存池中去,询问即将(已经)进入到屏幕的cell,对于还没有进入到屏幕的ce			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xQJYB3.html" rel="bookmark">IOS开发笔记－百度地图&lpar;第三方库&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近做了百度地图,在导入SDK后遇到了一些问题 编译错误: linker command failed with exit code 1 (use -v to see invocation) 想了很多办法,查了很多资料,最后终于解决. 可能原因: 1. 有重复的.m文件,或者未导入 解决办法:有重复的删除即可 在工作左边导航栏Target--&gt;Build Phases--&gt;compile Sources中,第三库库的所有.m文件都添加到里面 2.Valid Architectures 的值 在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49LpVn3.html" rel="bookmark">android开发笔记之自定义开关按钮</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天来讲讲自定义单个控件,就拿开关按钮来讲讲,相信大家见了非常多这样的了,先看看效果: 我们可以看到一个很常见的开关按钮,那就来分析分析. 首先: 这是由两张图片构成: ①一张为有开和关的背景图片 ②一张为控制开和关的滑动按钮 第一步: 写个类继承View,并重写几个方法: 第一个为构造函数,重写一个参数的函数和两个参数的函数就够了,因为两个参数的函数能够使用自定义属性 第二个为控制控件的大小–&gt;protected void onMeasure(int widthMeasureSpec, int			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/v0kWld0.html" rel="bookmark" class="title">复习C&plus;&plus;：VS2008中的宏干嘛用的</a>
					<div>
						VS2008中有宏,可也进行编辑和设置. 好处: 1.快速生成代码,帮助开发. 2.个人定制化功能,IDE更合适自己用. 3.提升编程效率. 缺点: 使用VB开发,一开始用起来费事.不过有官方参考文档 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xPYk0.html" rel="bookmark" class="title">【记录】2016年5月</a>
					<div>
						[5月的记录帖] 开篇明义: 一直拖沓太多,自己也有一种得过且过的心思,养了些坏习惯,总是容易自我感动,而后便纵情娱乐,生活不止娱乐. 没有干货,憋了半天也憋不出东西来,一点点的记录下. 时间安排 学 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9ME5xgM.html" rel="bookmark" class="title">私营太空，如何在宇宙中圈地？</a>
					<div>
						人类的想象和欲望总是无限的,特别是对地球本身.宇宙外延的探索从未停止过,我们先是飞到空中,鸟瞰大地,得知地球不是一块方形的雪糕,更不是银河系,甚至太阳系的核心,点点星辰从来不是围绕地球在转动,大家都是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDR1yk3.html" rel="bookmark" class="title">安卓手机的加密设备和加密外置SD卡</a>
					<div>
						手机一旦被偷或者遗失,那么隐私就会泄露了,安卓手机中有&quot;加密设备&quot;和&quot;加密外置sd卡&quot;的功能.那么这两项功能有什么用有什么区别呢? 加密设备 加密设备后,内置S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j5An7M.html" rel="bookmark" class="title">UVA - 11582 Colossal Fibonacci Numbers&excl;循环节</a>
					<div>
						找Fn =( Fn-1 + Fn-2 ) mod n 的循环节 暴力找即可 1 #include &lt;cstdio&gt; 2 #include &lt;iostream&gt; 3 #inclu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDdKdoM.html" rel="bookmark" class="title">在Windows7中与虚拟机实现远程桌面连接</a>
					<div>
						在Windows7中与虚拟机实现远程桌面连接 在win7系统中安装VMware workstation虚拟机并安装win7系统,实现在win7宿主机中远程 连接虚拟机 右击宿主机&quot;网络&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPD2D6M.html" rel="bookmark" class="title">AOJ 491&period;扑克牌</a>
					<div>
						Time Limit: 1000 ms   Case Time Limit: 1000 ms   Memory Limit: 64 MBTotal Submission: 54   Submissio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mejk0.html" rel="bookmark" class="title">关于oracle数据库启动报ORA-01122，ORA-01110，ORA-01203错误的解决方法</a>
					<div>
						ORACLE 数据库空间裸设备出问题了,启动oracle失败,解决方法问题现象:     启动ORACLE的时候报如下的错误:        Database mounted.      ORA-01 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j1oYgM.html" rel="bookmark" class="title">TCP&sol;IP协议详解第2卷 第3章 接口层</a>
					<div>
						这章就是从ifnet来说起的,每个网络设备都有一个自己的ifnet结构,这个结构里有ifaddr链表,也就是每个接口的 所有地址,可以是一个,也可以是多个形成的链表.然后下面有一个ifqueue这就是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXnm2X3.html" rel="bookmark" class="title">Codeforces gym Hello 2015 Div1 C and Div2 E</a>
					<div>
						Codeforces gym 100570 problem C Codeforces gym 100571 problem E Problem 给一个N行M列的矩阵Ma,进行Q次(Q&lt;=10)查 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JdGNn0.html" rel="bookmark" class="title">数据结构合集</a>
					<div>
						线段树: 1.[codevs1690]开关灯 这道题是一道线段树裸题,可以开个标记记录当前节点被修改的次数,然后仿照区间修改区间查询来做就行了. 代码: uses math; type hh=reco ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Q7dRL0.html" rel="bookmark" class="title">Another MySQL daemon already running with the same unix socket&period;</a>
					<div>
						问题描述: 查看MySQL进程的状态: [[email protected] lib]# service mysqld statusmysqld is stopped 发现是关闭的,但是启动MySQL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k9pVd4.html" rel="bookmark" class="title">socket发送和接收数据</a>
					<div>
						1)sendBuf(),sendText(),sendStream() 几乎所有的通信控件都会提供上面的3个方法.首先看看SendBuf(). function TCustomWinSocket.Se ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGAOwQ3.html" rel="bookmark" class="title">Jdk1&period;8中的HashMap实现原理</a>
					<div>
						本文主要参考:美团点评技术团队 HashMap概述 HashMap是基于哈希表的Map接口的非同步实现.此实现提供所有可选的映射操作,并允许使用null值和null键.此类不保证映射的顺序,特别是它不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K8mGJ3.html" rel="bookmark" class="title">ThinkPHP 的模型使用详细介绍--模型的核心&lpar;七&rpar;</a>
					<div>
						原文:ThinkPHP 的模型使用详细介绍--模型的核心(七) 注意:本节是ThinkPhp框架对数据操作的核心处理部分 大家还是在这里看清楚可以将其剪切放到代码编辑器中查看 本章节给大家着重介绍模型 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWjvaB4.html" rel="bookmark" class="title">【机器学习】DBSCAN Algorithms基于密度的聚类算法</a>
					<div>
						一.算法思想: DBSCAN(Density-Based Spatial Clustering of Applications with Noise)是一个比较有代表性的基于密度的聚类算法.与划分和层 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l1VpP3.html" rel="bookmark" class="title">HRBUST1530</a>
					<div>
						链接 http://acm.hrbust.edu.cn/index.php?m=ProblemSet&amp;a=showProblem&amp;problem_id=1530 这个是典型的二分题,题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME1KWQM.html" rel="bookmark" class="title">php openssl 增加密钥</a>
					<div>
						  生成私钥:openssl genrsa 1024 &gt; private.key (注意,1024是密钥的长度,如果密钥较长,相应加密后的密文也会较长) 生成公钥:openssl rsa -in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pGkxV3.html" rel="bookmark" class="title">【Spring】Spring集成Quartz</a>
					<div>
						maven引入所需的jar包: &lt;dependency&gt; &lt;groupId&gt;org.quartz-scheduler&lt;/groupId&gt; &lt;artifactI ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3raeD90.html" rel="bookmark" class="title">sqlplus实现上下翻页设置</a>
					<div>
						环境: 操作系统:red hat 5.8 OS 数据库:oracle 11g 11.2.0.1 安装软件:IO-Tty-1.07.tar. Term-ReadLine-Gnu-1.16.tar.uni ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.050 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
